#ifndef lint
static char yysccsid[] = "@(#)yaccpar     1.7 (Berkeley) 09/09/90";
#endif
#define YYBYACC 1
#line 2 "syd91"

/* ----------------------------------------------------------- */
/* New in syd9: read, print.                                   */
/*          syd9 is divided into defs.h,syd91,syd92 & syd93.c  */
/* ----------------------------------------------------------- */
 
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>

#define MHNYMA 0

/* ----------------------------------------------------------- */
/* --------- Declarations for Syntax-Semantic Analysis ------- */
/* ----------------------------------------------------------- */

#include "defs.h"

symbol *Cross_Link_Head[MAX_CROSS_LINKS];

typedef struct hash_tab {
   int numbsymbols;
   symbol *table[SYM_TABLE_SIZE];
} HASH_TAB;

HASH_TAB ht;

int TopOfStack=-1;
symbol *vs[30];

symbol *Symbol_free=NULL; /* -- Symbol-list of recycled symbols -- */
symbol *p,*p1,*p2,*p3;

AstNode *TreeRoot;

#line 40 "syd91"
typedef union
{
    int   yint;
    char  ystr[81];
    struct AstNode_tag *stnode;
} YYSTYPE;
#line 50 "y_tab.c"
#define AND 257
#define ELSE 258
#define IF 259
#define INT 260
#define NOT 261
#define OR 262
#define PRINT 263
#define READ 264
#define WHILE 265
#define DEC_CONST 266
#define GE 267
#define LE 268
#define NE 269
#define EQ 270
#define ID 271
#define YYERRCODE 256
short yylhs[] = {                                        -1,
    0,    0,    1,    1,    2,    3,    6,    5,    5,    4,
    7,    8,    9,    9,   10,   12,   11,   11,   11,   11,
   11,   14,   16,   17,   15,   13,   18,   18,   20,   19,
   21,   21,   22,   23,   23,   23,   23,   24,   24,   24,
   25,   25,   25,   25,   25,   25,   25,   26,   26,   27,
};
short yylen[] = {                                         2,
    0,    4,    0,    2,    3,    1,    1,    1,    3,    1,
    1,    1,    0,    2,    1,    1,    1,    1,    1,    1,
    1,    2,    5,    5,    1,    3,    1,    1,    1,    1,
    1,    3,    1,    1,    3,    3,    3,    1,    3,    3,
    1,    3,    3,    3,    3,    3,    3,    1,    3,    1,
};
short yydefred[] = {                                      0,
    3,    0,    0,    6,    4,    0,    0,    0,   11,    8,
    0,    0,   10,    2,    0,    0,   29,    0,   13,   25,
   30,   14,   16,   15,   21,   17,   20,   18,   19,    0,
   28,   27,   33,   34,    0,    0,    0,   50,    0,    0,
    5,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   22,    9,    0,
    0,   32,   26,   49,   31,   35,   36,   37,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   24,   23,
};
short yydgoto[] = {                                       2,
    3,    5,    6,   10,   11,   12,   13,    7,    8,   22,
   23,   24,   25,   26,   27,   28,   29,   65,   31,   32,
   33,   34,   35,   36,   37,   38,   39,
};
short yysindex[] = {                                   -114,
    0,    0, -247,    0,    0, -252, -101,  -19,    0,    0,
  -18,  -31,    0,    0,    7,   10,    0,  -23,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   -6,
    0,    0,    0,    0,   19,  -27,  -59,    0,   14, -252,
    0,  -23, -259,   -9,  -29,  -23,  -23,  -23,  -23,  -23,
  -23,  -23,  -23,  -23,  -23,  -23,  -23,    0,    0,   -5,
   34,    0,    0,    0,    0,    0,    0,    0,   19,   19,
  -27,  -27,  -27,  -27,  -27,  -27,   20,   22,    0,    0,
};
short yyrindex[] = {                                     89,
    0,    0,  -25,    0,    0,    0,    0,  -30,    0,    0,
   38,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  -37,
    0,    0,    0,    0,  -14,    3,  -39,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   -8,   -2,
    8,   12,   18,   23,   28,   43,    0,    0,    0,    0,
};
short yygindex[] = {                                      0,
    0,    0,    0,   59,    0,    0,    0,    0,   82,    0,
    0,    0,    0,    0,    0,    0,    0,   68,    0,    0,
    0,   44,   56,   63,    0,    0,   -4,
};
#define YYTABLESIZE 313
short yytable[] = {                                      31,
   55,   48,   53,   31,   31,   31,   17,   31,    1,   31,
   18,   21,    4,   44,   13,   50,   18,   51,    9,   48,
   18,   31,   31,   14,   31,   40,   38,   41,   38,   20,
   38,   62,   39,   13,   39,   77,   39,   60,   40,   20,
   40,   64,   40,   41,   38,   38,   42,   38,   43,   43,
   39,   39,   42,   39,   46,   49,   40,   40,   45,   40,
   47,   41,   41,   44,   41,   48,   43,   43,   47,   43,
   42,   42,   58,   42,   78,   30,   45,   45,   79,   45,
   80,   44,   44,   46,   44,   30,   47,   47,    1,   47,
   66,   67,   68,   19,   12,   63,    7,   13,   59,   13,
   45,   46,   46,   19,   46,   69,   70,    0,    0,   30,
   61,    0,   30,   30,   71,   72,   73,   74,   75,   76,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   52,   54,   56,
   57,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   31,
   31,   31,   31,   15,   16,    0,   17,   13,   13,    0,
   13,   21,   17,   15,   16,   13,   17,   21,    0,    0,
    0,   21,   38,   38,   38,   38,    0,    0,   39,   39,
   39,   39,    0,    0,   40,   40,   40,   40,    0,   41,
   41,   41,   41,    0,   43,   43,   43,   43,   42,   42,
   42,   42,    0,    0,   45,   45,   45,   45,    0,   44,
   44,   44,   44,    0,   47,   47,   47,   47,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   46,
   46,   46,   46,
};
short yycheck[] = {                                      37,
   60,   41,   62,   41,   42,   43,  266,   45,  123,   47,
   40,  271,  260,   18,   40,   43,   40,   45,  271,   59,
   40,   59,   60,  125,   62,   44,   41,   59,   43,   59,
   45,   41,   41,   59,   43,   41,   45,   42,   41,   59,
   43,   46,   45,   41,   59,   60,   40,   62,   41,   40,
   59,   60,   41,   62,   61,   37,   59,   60,   41,   62,
   42,   59,   60,   41,   62,   47,   59,   60,   41,   62,
   59,   60,   59,   62,   41,    8,   59,   60,   59,   62,
   59,   59,   60,   41,   62,   18,   59,   60,    0,   62,
   47,   48,   49,  123,  125,  125,   59,  123,   40,  125,
   19,   59,   60,  123,   62,   50,   51,   -1,   -1,   42,
   43,   -1,   45,   46,   52,   53,   54,   55,   56,   57,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  267,  268,  269,
  270,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  267,
  268,  269,  270,  263,  264,   -1,  266,  263,  264,   -1,
  266,  271,  266,  263,  264,  271,  266,  271,   -1,   -1,
   -1,  271,  267,  268,  269,  270,   -1,   -1,  267,  268,
  269,  270,   -1,   -1,  267,  268,  269,  270,   -1,  267,
  268,  269,  270,   -1,  267,  268,  269,  270,  267,  268,
  269,  270,   -1,   -1,  267,  268,  269,  270,   -1,  267,
  268,  269,  270,   -1,  267,  268,  269,  270,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  267,
  268,  269,  270,
};
#define YYFINAL 2
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 271
#if YYDEBUG
char *yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,"'%'",0,0,"'('","')'","'*'","'+'","','","'-'",0,"'/'",0,0,0,0,0,0,0,0,0,0,
0,"';'","'<'","'='","'>'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"'{'",0,"'}'",
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,"AND","ELSE","IF","INT","NOT","OR","PRINT","READ","WHILE",
"DEC_CONST","GE","LE","NE","EQ","ID",
};
char *yyrule[] = {
"$accept : Program",
"Program :",
"Program : '{' DeclSeq StmtSeq '}'",
"DeclSeq :",
"DeclSeq : DeclSeq Declaration",
"Declaration : StdType DcltrSeq ';'",
"StdType : INT",
"DcltrSeq : Dcltr1OrMore",
"Dcltr1OrMore : Declarator",
"Dcltr1OrMore : Dcltr1OrMore ',' Declarator",
"Declarator : Name",
"Name : ID",
"StmtSeq : Stmt0OrMore",
"Stmt0OrMore :",
"Stmt0OrMore : Stmt0OrMore Statement",
"Statement : BalStmt",
"BalStmt : BasicStmt",
"BasicStmt : eStmt",
"BasicStmt : ReadStmt",
"BasicStmt : PrintStmt",
"BasicStmt : NullStmt",
"BasicStmt : CompStmt",
"eStmt : Expr ';'",
"ReadStmt : READ '(' PrimExpr ')' ';'",
"PrintStmt : PRINT '(' Expr ')' ';'",
"NullStmt : ';'",
"CompStmt : '{' Stmt0OrMore '}'",
"PrimExpr : Literal",
"PrimExpr : Var",
"Literal : DEC_CONST",
"Var : ID",
"ParenExpr : PrimExpr",
"ParenExpr : '(' Expr ')'",
"PrefixExpr : ParenExpr",
"MultExpr : PrefixExpr",
"MultExpr : MultExpr '*' PrefixExpr",
"MultExpr : MultExpr '/' PrefixExpr",
"MultExpr : MultExpr '%' PrefixExpr",
"AddExpr : MultExpr",
"AddExpr : AddExpr '+' MultExpr",
"AddExpr : AddExpr '-' MultExpr",
"RelExpr : AddExpr",
"RelExpr : RelExpr '>' AddExpr",
"RelExpr : RelExpr GE AddExpr",
"RelExpr : RelExpr '<' AddExpr",
"RelExpr : RelExpr LE AddExpr",
"RelExpr : RelExpr EQ AddExpr",
"RelExpr : RelExpr NE AddExpr",
"AssignExpr : RelExpr",
"AssignExpr : PrimExpr '=' Expr",
"Expr : AssignExpr",
};
#endif
#define yyclearin (yychar=(-1))
#define yyerrok (yyerrflag=0)
#ifdef YYSTACKSIZE
#ifndef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#endif
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 600
#define YYMAXDEPTH 600
#endif
#endif
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short yyss[YYSTACKSIZE];
YYSTYPE yyvs[YYSTACKSIZE];
#define yystacksize YYSTACKSIZE
#line 533 "syd91"

#include "syd92"
#line 289 "y_tab.c"
#define YYABORT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab
int
yyparse()
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register char *yys;
    extern char *getenv();

    if (yys = getenv("YYDEBUG"))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if (yyn = yydefred[yystate]) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("yydebug: state %d, reading %d (%s)\n", yystate,
                    yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("yydebug: state %d, shifting to state %d\n",
                    yystate, yytable[yyn]);
#endif
        if (yyssp >= yyss + yystacksize - 1)
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#ifdef lint
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#ifdef lint
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("yydebug: state %d, error recovery shifting\
 to state %d\n", *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yyss + yystacksize - 1)
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("yydebug: error recovery discarding state %d\n",
                            *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("yydebug: state %d, error recovery discards token %d (%s)\n",
                    yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("yydebug: state %d, reducing by rule %d (%s)\n",
                yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 1:
#line 65 "syd91"
{
#if MHNYMA
                        printf("/0\n");
#endif
                        TreeRoot=MkNode(astEmptyProgram,NULL,NULL,NULL,NULL,NULL);
                     }
break;
case 2:
#line 72 "syd91"
{
#if MHNYMA
                        printf("/1\n");
#endif
                        TreeRoot=MkNode(astProgram,NULL,yyvsp[-2].stnode,yyvsp[-1].stnode,NULL,NULL);
                     }
break;
case 3:
#line 80 "syd91"
{
#if MHNYMA
                        printf("/2\n");
#endif
                        yyval.stnode=MkNode(astEmptyDeclSeq,NULL,NULL,NULL,NULL,NULL);
                     }
break;
case 4:
#line 87 "syd91"
{ 
#if MHNYMA
                        printf("/3\n");
#endif
                        yyval.stnode=MkNode(astDeclSeq,NULL,yyvsp[-1].stnode,yyvsp[0].stnode,NULL,NULL);
                     }
break;
case 5:
#line 95 "syd91"
{ 
#if MHNYMA
                        printf("/4\n");
#endif
                        yyval.stnode=MkNode(astDecl,NULL,yyvsp[-2].stnode,yyvsp[-1].stnode,NULL,NULL);
                        p2=pop_vs();
                        p1=pop_vs();
                        cpy_attributes(p2,p1);
                        p2=reverse_cross_links(p2);
                        Link_Symbol_to_Cross_Link(p2);
                        add_symbols_to_table(p2);
                        discard_symbol(p1);
                     }
break;
case 6:
#line 110 "syd91"
{ 
#if MHNYMA
                        printf("/5\n");
#endif
                        yyval.stnode=MkNode(INT,NULL,NULL,NULL,NULL,NULL); 
                        p1=new_symbol("");
                        set_class_types(p1,yyvsp[0].yint);
                        p1->disposable=TRUE;
                        push_vs(p1);
                     }
break;
case 7:
#line 122 "syd91"
{ 
#if MHNYMA
                        printf("/6\n");
#endif
                        yyval.stnode=yyvsp[0].stnode;
                     }
break;
case 8:
#line 130 "syd91"
{ 
#if MHNYMA
                        printf("/7\n");
#endif
                        yyval.stnode=yyvsp[0].stnode;
                     }
break;
case 9:
#line 137 "syd91"
{  
#if MHNYMA
                        printf("/8\n");
#endif
                        yyval.stnode=MkNode(astDcltrSeq,NULL,yyvsp[-2].stnode,yyvsp[0].stnode,NULL,NULL);
                        p3=pop_vs();
                        p1=pop_vs();
                        p3->Next_in_Cross_Link=p1;
                        push_vs(p3);
                     }
break;
case 10:
#line 149 "syd91"
{ 
#if MHNYMA
                        printf("/9\n");
#endif
                        yyval.stnode=yyvsp[0].stnode;
                     }
break;
case 11:
#line 157 "syd91"
{ 
#if MHNYMA
                        printf("/10\n");
#endif
                        p1=new_symbol(yyvsp[0].ystr);
                        yyval.stnode=MkNode(astVarDcltr,p1,NULL,NULL,NULL,NULL);
                        push_vs(p1); 
                     }
break;
case 12:
#line 167 "syd91"
{ 
#if MHNYMA
                        printf("/11\n");
#endif
                        (void)pop_vs();
                        yyval.stnode=yyvsp[0].stnode;
                     }
break;
case 13:
#line 176 "syd91"
{ 
#if MHNYMA
                        printf("/12\n");
#endif
                        yyval.stnode=MkNode(astEmptyStmtSeq,NULL,NULL,NULL,NULL,NULL); 
                        push_vs(NULL);
                     }
break;
case 14:
#line 184 "syd91"
{ 
#if MHNYMA
                        printf("/13\n");
#endif
                        yyval.stnode=MkNode(astStmtSeq,NULL,yyvsp[-1].stnode,yyvsp[0].stnode,NULL,NULL); 
                        (void)pop_vs();
                        (void)pop_vs();
                        push_vs(NULL);
                     }
break;
case 15:
#line 195 "syd91"
{ 
#if MHNYMA
                        printf("/14\n");
#endif
                        yyval.stnode=yyvsp[0].stnode; 
                     }
break;
case 16:
#line 203 "syd91"
{ 
#if MHNYMA
                        printf("/15\n");
#endif
                        yyval.stnode=yyvsp[0].stnode; 
                     }
break;
case 17:
#line 211 "syd91"
{ 
#if MHNYMA
                        printf("/16\n");
#endif
                        yyval.stnode=yyvsp[0].stnode;
                     }
break;
case 18:
#line 218 "syd91"
{ 
#if MHNYMA
                        printf("13\n");
#endif
                        yyval.stnode=yyvsp[0].stnode;
                     }
break;
case 19:
#line 225 "syd91"
{  
#if MHNYMA
                        printf("14\n");
#endif
                        yyval.stnode=yyvsp[0].stnode;
                     }
break;
case 20:
#line 232 "syd91"
{  
#if MHNYMA
                        printf("/17\n");
#endif
                        yyval.stnode=yyvsp[0].stnode;
                     }
break;
case 21:
#line 239 "syd91"
{  
#if MHNYMA
                        printf("/18\n");
#endif
                        yyval.stnode=yyvsp[0].stnode;
                     }
break;
case 22:
#line 247 "syd91"
{ 
#if MHNYMA
                        printf("/19\n");
#endif
                        yyval.stnode=MkNode(astExprStmt,NULL,yyvsp[-1].stnode,NULL,NULL,NULL); 
                     }
break;
case 23:
#line 255 "syd91"
{ 
#if MHNYMA
                        printf("36\n");
#endif
                        yyval.stnode=MkNode(astReadStmt,NULL,yyvsp[-2].stnode,NULL,NULL,NULL);
                        p3=pop_vs();
                        check_read(p3);
                        push_vs(NULL);
                     }
break;
case 24:
#line 266 "syd91"
{ 
#if MHNYMA
                        printf("37\n");
#endif
                        yyval.stnode=MkNode(astPrintStmt,NULL,yyvsp[-2].stnode,NULL,NULL,NULL);
                        p3=pop_vs();
                        check_print(p3);
                        push_vs(NULL);
                     }
break;
case 25:
#line 277 "syd91"
{ 
#if MHNYMA
                        printf("/20\n");
#endif
                        yyval.stnode=MkNode(astNullStmt,NULL,NULL,NULL,NULL,NULL);
                        push_vs(NULL);
                     }
break;
case 26:
#line 286 "syd91"
{ 
#if MHNYMA
                        printf("/21\n");
#endif
                        yyval.stnode=yyvsp[-1].stnode; 
                     }
break;
case 27:
#line 294 "syd91"
{ 
#if MHNYMA
                        printf("/22\n");
#endif
                        yyval.stnode=yyvsp[0].stnode; 
                     }
break;
case 28:
#line 301 "syd91"
{ 
#if MHNYMA
                        printf("/23\n");
#endif
                        yyval.stnode=yyvsp[0].stnode;
                     }
break;
case 29:
#line 309 "syd91"
{  
#if MHNYMA
                        printf("/24\n");
#endif
                        p1=new_symbol(yyvsp[0].ystr);
                        p1->typos=INT;
                        p1->disposable=FALSE;
                        p1->lvalue=FALSE;
                        p1->timi=atoi(yyvsp[0].ystr);
                        push_vs(p1);
                        yyval.stnode=MkNode(astDecimConst,p1,NULL,NULL,NULL,NULL);
                     }
break;
case 30:
#line 323 "syd91"
{
#if MHNYMA
                        printf("/25\n");
#endif
                        p1=findsymb(yyvsp[0].ystr);
                        if(!p1) {
                           printf("Identifier not declared\n");
                           exit(1);
                        }
                        yyval.stnode=MkNode(astId,p1,NULL,NULL,NULL,NULL);
                        p1=create_id(p1);
                        push_vs(p1);
                     }
break;
case 31:
#line 338 "syd91"
{
#if MHNYMA
                        printf("/26\n");
#endif
                        yyval.stnode=yyvsp[0].stnode; 
                     }
break;
case 32:
#line 345 "syd91"
{ 
#if MHNYMA
                        printf("/27\n");
#endif
                        yyval.stnode=yyvsp[-1].stnode; 
                     }
break;
case 33:
#line 353 "syd91"
{ 
#if MHNYMA
                        printf("/28\n");
#endif
                        yyval.stnode=yyvsp[0].stnode; 
                     }
break;
case 34:
#line 361 "syd91"
{ 
#if MHNYMA
                        printf("/29\n");
#endif
                        yyval.stnode=yyvsp[0].stnode; 
                     }
break;
case 35:
#line 368 "syd91"
{   
#if MHNYMA
                        printf("/30\n");
#endif
                        p3=pop_vs();
                        p1=pop_vs();
                        yyval.stnode=MkNode(astMult,NULL,yyvsp[-2].stnode,yyvsp[0].stnode,NULL,NULL);
                        p=check_multop(p1,p3);
                        push_vs(p);
                     }
break;
case 36:
#line 379 "syd91"
{ 
#if MHNYMA
                        printf("/31\n");
#endif
                        p3=pop_vs();
                        p1=pop_vs();
                        yyval.stnode=MkNode(astDiv,NULL,yyvsp[-2].stnode,yyvsp[0].stnode,NULL,NULL);
                        p=check_divop(p1,p3);
                        push_vs(p);
                     }
break;
case 37:
#line 390 "syd91"
{ 
#if MHNYMA
                        printf("/32\n");
#endif
                        p3=pop_vs();
                        p1=pop_vs();
                        yyval.stnode=MkNode(astMod,NULL,yyvsp[-2].stnode,yyvsp[0].stnode,NULL,NULL);
                        p=check_modop(p1,p3);
                        push_vs(p);
                     }
break;
case 38:
#line 402 "syd91"
{ 
#if MHNYMA
                        printf("/33\n");
#endif
                        yyval.stnode=yyvsp[0].stnode; 
                     }
break;
case 39:
#line 409 "syd91"
{ 
#if MHNYMA
                        printf("/34\n");
#endif
                        p3=pop_vs();
                        p1=pop_vs();
                        yyval.stnode=MkNode(astAdd,NULL,yyvsp[-2].stnode,yyvsp[0].stnode,NULL,NULL);
                        p=check_addop(p1,p3);
                        push_vs(p);
                     }
break;
case 40:
#line 420 "syd91"
{ 
#if MHNYMA
                        printf("/35\n");
#endif
                        p3=pop_vs();
                        p1=pop_vs();
                        yyval.stnode=MkNode(astSub,NULL,yyvsp[-2].stnode,yyvsp[0].stnode,NULL,NULL);
                        p=check_subop(p1,p3);
                        push_vs(p);
                     }
break;
case 41:
#line 432 "syd91"
{ 
#if MHNYMA
                        printf("/36\n");
#endif
                        yyval.stnode=yyvsp[0].stnode; 
                     }
break;
case 42:
#line 439 "syd91"
{ 
#if MHNYMA
                        printf("/37\n");
#endif
                        p3=pop_vs();
                        p1=pop_vs();
                        yyval.stnode=MkNode(astGreater,NULL,yyvsp[-2].stnode,yyvsp[0].stnode,NULL,NULL);
                        p=check_gtop(p1,p3);
                        push_vs(p);
                     }
break;
case 43:
#line 450 "syd91"
{ 
#if MHNYMA
                        printf("/38\n");
#endif
                        p3=pop_vs();
                        p1=pop_vs();
                        yyval.stnode=MkNode(astGrEq,NULL,yyvsp[-2].stnode,yyvsp[0].stnode,NULL,NULL);
                        p=check_geop(p1,p3);
                        push_vs(p);
                     }
break;
case 44:
#line 461 "syd91"
{ 
#if MHNYMA
                        printf("/39\n");
#endif
                        p3=pop_vs();
                        p1=pop_vs();
                        yyval.stnode=MkNode(astLess,NULL,yyvsp[-2].stnode,yyvsp[0].stnode,NULL,NULL);
                        p=check_ltop(p1,p3);
                        push_vs(p);
                     }
break;
case 45:
#line 472 "syd91"
{ 
#if MHNYMA
                        printf("/40\n");
#endif
                        p3=pop_vs();
                        p1=pop_vs();
                        yyval.stnode=MkNode(astLeEq,NULL,yyvsp[-2].stnode,yyvsp[0].stnode,NULL,NULL);
                        p=check_leop(p1,p3);
                        push_vs(p);
                     }
break;
case 46:
#line 483 "syd91"
{ 
#if MHNYMA
                        printf("/41\n");
#endif
                        p3=pop_vs();
                        p1=pop_vs();
                        yyval.stnode=MkNode(astEq,NULL,yyvsp[-2].stnode,yyvsp[0].stnode,NULL,NULL);
                        p=check_eqop(p1,p3);
                        push_vs(p);
                     }
break;
case 47:
#line 494 "syd91"
{ 
#if MHNYMA
                        printf("/42\n");
#endif
                        p3=pop_vs();
                        p1=pop_vs();
                        yyval.stnode=MkNode(astNotEq,NULL,yyvsp[-2].stnode,yyvsp[0].stnode,NULL,NULL);
                        p=check_neop(p1,p3);
                        push_vs(p);
                     }
break;
case 48:
#line 506 "syd91"
{ 
#if MHNYMA
                        printf("/43\n");
#endif
                        yyval.stnode=yyvsp[0].stnode; 
                     }
break;
case 49:
#line 513 "syd91"
{ 
#if MHNYMA
                        printf("/44\n");
#endif
                        p3=pop_vs();
                        p1=pop_vs();
                        yyval.stnode=MkNode(astAssign,NULL,yyvsp[-2].stnode,yyvsp[0].stnode,NULL,NULL);
                        p=check_assignment(p1,p3);
                        push_vs(p);
                     }
break;
case 50:
#line 525 "syd91"
{ 
#if MHNYMA
                        printf("/45\n");
#endif
                        yyval.stnode=yyvsp[0].stnode;
                     }
break;
#line 969 "y_tab.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("yydebug: after reduction, shifting from state 0 to\
 state %d\n", YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("yydebug: state %d, reading %d (%s)\n",
                        YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("yydebug: after reduction, shifting from state %d \
to state %d\n", *yyssp, yystate);
#endif
    if (yyssp >= yyss + yystacksize - 1)
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
